﻿using System;
using System.Globalization;
using System.Collections.Generic;
using System.Collections.Concurrent;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Net;
using System.Net.Sockets;
using System.Xml;
using System.Reflection;
using Microsoft.Win32;
using RFID.Reader;
using RFID.ReaderComm;


namespace ReadingTags
{

    class ReadingTags
    {
        static String DEFAULT_READER_IP_ADDRESS = "192.168.1.120";
        static UInt16 PORT_NUMBER = 5000;
        public static RFIDReader reader = null;
        public static Boolean reading = false;


        static void Main(string[] args)
        {
            String readerIPAddress = DEFAULT_READER_IP_ADDRESS;
            UInt16 PortNumber = PORT_NUMBER;

            Console.WriteLine("Setting up ReaderComm instance on IP Address " + readerIPAddress);

            reader = new RFIDReader(readerIPAddress, PortNumber, PrintInfo);

            Console.WriteLine("Getting Reader Info\n");
            ReaderInfo();
            ReadTest();
        }

        public static void ReaderInfo()
        {
            string id = "";
            RFIDStatus status = ReadingTags.reader.GetHardwareId(ref id);
            Console.WriteLine("SensArray Hardware Id: " + id);
        }

        public static void ReadTest()
        {
            Console.WriteLine("Starting Continuous Read ...");
            ReadingTags.reading = true;
            ReadingTags.reader.StartContinuousRead();

            //Read for 20 seconds, and then issue stop command.
            Thread.Sleep(20000);

            Console.WriteLine("Stopping Continuous Read ...");
            ReadingTags.reader.StopContinuousRead();

            //While loop to read queued up tag data, and to wait for the stop command response.

            while (ReadingTags.reading)
            {
                Thread.Sleep(10);
            }
        }

        public static void PrintInfo(TagReadInfo readInfo)
        {
            if (readInfo.status == RFIDStatus.OK)
                Console.WriteLine(readInfo.EPC);
            else if (readInfo.status == RFIDStatus.DONE)
            {
                ReadingTags.reading = false;
                Console.WriteLine("Received Stop Response");
            }
        }

        
    }
    
   
}
    