﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using RFID.Reader;
using RFID.ReaderComm;
using System.Threading;

namespace SetEPCFilter
{
    class SetEPCFilter
    {
        const String DEFAULT_READER_IP_ADDRESS = "192.168.1.120";
        const UInt16 PORT_NUMBER = 5000;
        const int maxResoponseSize = 1000;
        static String[] TAG_EPC_FILTER = { "66", "66", "66", "66", "66", "66" };
        public static RFIDReader reader = null;
        public static Boolean reading = false;


        static void Main(string[] args)
        {
            String readerIPAddress = DEFAULT_READER_IP_ADDRESS;
            UInt16 PortNumber = PORT_NUMBER;

            Console.WriteLine("Setting up ReaderComm instance on IP Address " + readerIPAddress);

            reader = new RFIDReader(readerIPAddress, PortNumber, PrintInfo);

            SetEPCFilter.TagReadEPCFilter(0);
            SetEPCFilter.ReadTest();
            SetEPCFilter.reader.ClearInventoryFilter(true);
        }

        public static void TagReadEPCFilter(int startAddress)
        {
            try
            {
                String[] tagEPCFilter = TAG_EPC_FILTER;
                Byte filterBank = 1; 
                UInt16 filterAddress = (UInt16)(32 + startAddress);
                UInt16 filterBitLength = (UInt16)tagEPCFilter.Length;
                Byte[] filterMask = new Byte[12];

                int bytesInMask = tagEPCFilter.Length;
                if (bytesInMask > filterMask.Length)
                    bytesInMask = filterMask.Length;

                for (int idx = 0; idx < bytesInMask; idx++)
                    filterMask[idx] = Byte.Parse(tagEPCFilter[idx], System.Globalization.NumberStyles.HexNumber);

                SetEPCFilter.reader.SetInventoryFilter(filterBank, filterAddress, filterBitLength, filterMask, true);

            }
            catch (Exception ex)
            {
                Console.WriteLine("Filter failed to set. " + ex);
            }
        }
        public static void ReaderInfo()
        {
            string id = "";
            RFIDStatus status = SetEPCFilter.reader.GetHardwareId(ref id);
            Console.WriteLine("SensArray Hardware Id: " + id);
        }

        public static void ReadTest()
        {
            Console.WriteLine("Starting Continuous Read ...");
            SetEPCFilter.reading = true;
            SetEPCFilter.reader.StartContinuousRead();

            //Read for 20 seconds, and then issue stop command.
            Thread.Sleep(20000);

            Console.WriteLine("Stopping Continuous Read ...");
            SetEPCFilter.reader.StopContinuousRead();

            //While loop to read queued up tag data, and to wait for the stop command response.

            while (SetEPCFilter.reading)
            {
                Thread.Sleep(10);
            }
        }

        public static void PrintInfo(TagReadInfo readInfo)
        {
            if (readInfo.status == RFIDStatus.OK)
                Console.WriteLine(readInfo.EPC);
            else if (readInfo.status == RFIDStatus.DONE)
            {
                SetEPCFilter.reading = false;
                Console.WriteLine("Received Stop Response");
            }
        }


    }
}
